// callback.cpp

#include "stdafx.h"

#include "ICsParserCallback.h"
#include "IAssembly.h"
#include "IAssemblyInfo.h"

#include "CommandLineOptions.h"
#include "FileManager.h"

//------------------------------------------------------------------------------
// ICsParserCallback
//------------------------------------------------------------------------------

IAssembly * ICsParserCallback::loadAssembly
	( const IAssemblyInfo * assemblyInfo, const IAssembly * assembly_from )
{
	if ( !assemblyInfo->bFile ) // AssemblyRef  Table
	{
		std::vector<std::string> & include_assemblies_paths
			= getCommandLineOptions().include_assemblies_paths;

		for ( int i = 0; i != include_assemblies_paths.size(); ++i )
		{
			std::string assembly_name = assemblyInfo->Name;
			assembly_name += ".dll";
			std::string path;
			ConcatPathFile ( include_assemblies_paths[i].c_str(), assembly_name.c_str(), path );
			PFile file = new File ( path.c_str() );
			IAssembly * iassembly = process_assembly ( file );
			if ( iassembly )
				return iassembly;
		}
	}
	else // File Table (multifile assembly) - search file in directory where "main" module placed
	{
		std::string directory;
		if ( !GetDirectoryFromPath ( assembly_from->getPath(), directory ) )
		{
			ASSERT(0);
			return 0;
		}

		std::string path;
		ConcatPathFile ( directory.c_str(), assemblyInfo->Name, path );

		PFile file = new File ( path.c_str() );
		IAssembly * iassembly = process_assembly ( file );
		if ( iassembly )
			return iassembly;
	}

	ASSERT(0);
	return 0;
}

//------------------------------------------------------------------------------
